Index: /code/branches/buildsystem/CMakeLists.txt
===================================================================
--- /code/branches/buildsystem/CMakeLists.txt	(revision 1974)
+++ /code/branches/buildsystem/CMakeLists.txt	(revision 1975)
@@ -100,5 +100,5 @@
 FIND_PACKAGE(OggVorbis)
 FIND_PACKAGE(ZLIB)
-#FIND_PACKAGE(Lua)
+FIND_PACKAGE(Lua50)
 FIND_PACKAGE(TCL)
 FIND_PACKAGE(DirectX)
Index: /code/branches/buildsystem/cmake/FindLua50.cmake
===================================================================
--- /code/branches/buildsystem/cmake/FindLua50.cmake	(revision 1975)
+++ /code/branches/buildsystem/cmake/FindLua50.cmake	(revision 1975)
@@ -0,0 +1,101 @@
+# Locate Lua library
+# This module defines
+#  LUA_LIBRARIES, both lua and lualib
+#  LUA_FOUND, if false, do not try to link to Lua 
+#  LUA_INCLUDE_DIR, where to find lua.h and lualib.h (and probably lauxlib.h)
+#
+# Note that the expected include convention is
+#  #include "lua.h"
+# and not
+#  #include <lua/lua.h>
+# This is because, the lua location is not standardized and may exist
+# in locations other than lua/
+
+
+FIND_PATH(LUA_INCLUDE_DIR lua.h
+  PATHS
+  $ENV{LUA_DIR}
+  NO_DEFAULT_PATH
+  PATH_SUFFIXES include/lua50 include/lua5.0 include/lua5 include/lua include
+)
+
+FIND_PATH(LUA_INCLUDE_DIR lua.h
+  PATHS
+  ~/Library/Frameworks
+  /Library/Frameworks
+  /usr/local
+  /usr
+  /sw # Fink
+  /opt/local # DarwinPorts
+  /opt/csw # Blastwave
+  /opt
+  PATH_SUFFIXES include/lua50 include/lua5.0 include/lua5 include/lua include
+)
+
+FIND_LIBRARY(LUA_LIBRARY_lua 
+  NAMES lua50 lua5.0 lua5 lua
+  PATHS
+  $ENV{LUA_DIR}
+  NO_DEFAULT_PATH
+    PATH_SUFFIXES lib64 lib
+)
+
+FIND_LIBRARY(LUA_LIBRARY_lua
+  NAMES lua50 lua5.0 lua5 lua
+  PATHS
+  ~/Library/Frameworks
+  /Library/Frameworks
+  /usr/local
+  /usr
+  /sw
+  /opt/local
+  /opt/csw
+  /opt
+    PATH_SUFFIXES lib64 lib
+)
+
+# In an OS X framework, lualib is usually included as part of the framework
+# (like GLU in OpenGL.framework)
+IF(${LUA_LIBRARY_lua} MATCHES "framework")
+  SET( LUA_LIBRARIES "${LUA_LIBRARY_lua}" CACHE STRING "Lua framework")
+ELSE(${LUA_LIBRARY_lua} MATCHES "framework")
+  FIND_LIBRARY(LUA_LIBRARY_lualib 
+    NAMES lualib50 lualib5.0 lualib5 lualib
+    PATHS
+    $ENV{LUALIB_DIR}
+    $ENV{LUA_DIR}
+    NO_DEFAULT_PATH
+    PATH_SUFFIXES lib64 lib
+  )
+
+  FIND_LIBRARY(LUA_LIBRARY_lualib 
+    NAMES lualib50 lualib5.0 lualib5 lualib
+    PATHS
+    /usr/local
+    /usr
+    /sw
+    /opt/local
+    /opt/csw
+    /opt
+    PATH_SUFFIXES lib64 lib
+  )
+  IF(LUA_LIBRARY_lualib AND LUA_LIBRARY_lua)
+    # include the math library for Unix
+    IF(UNIX AND NOT APPLE)
+      FIND_LIBRARY(MATH_LIBRARY_FOR_LUA m)
+      SET( LUA_LIBRARIES "${LUA_LIBRARY_lualib};${LUA_LIBRARY_lua};${MATH_LIBRARY_FOR_LUA}" CACHE STRING "This is the concatentation of lua and lualib libraries")
+    # For Windows and Mac, don't need to explicitly include the math library
+    ELSE(UNIX AND NOT APPLE)
+      SET( LUA_LIBRARIES "${LUA_LIBRARY_lualib};${LUA_LIBRARY_lua}" CACHE STRING "This is the concatentation of lua and lualib libraries")
+    ENDIF(UNIX AND NOT APPLE)
+  ENDIF(LUA_LIBRARY_lualib AND LUA_LIBRARY_lua)
+ENDIF(${LUA_LIBRARY_lua} MATCHES "framework")
+
+
+INCLUDE(FindPackageHandleStandardArgs)
+# handle the QUIETLY and REQUIRED arguments and set LUA_FOUND to TRUE if 
+# all listed variables are TRUE
+FIND_PACKAGE_HANDLE_STANDARD_ARGS(Lua50  DEFAULT_MSG  LUA_LIBRARIES LUA_INCLUDE_DIR)
+
+MARK_AS_ADVANCED(LUA_INCLUDE_DIR LUA_LIBRARIES)
+
Index: /code/branches/buildsystem/cmake/FindLua51.cmake
===================================================================
--- /code/branches/buildsystem/cmake/FindLua51.cmake	(revision 1975)
+++ /code/branches/buildsystem/cmake/FindLua51.cmake	(revision 1975)
@@ -0,0 +1,74 @@
+# Locate Lua library
+# This module defines
+#  LUA_LIBRARIES
+#  LUA_FOUND, if false, do not try to link to Lua 
+#  LUA_INCLUDE_DIR, where to find lua.h 
+#
+# Note that the expected include convention is
+#  #include "lua.h"
+# and not
+#  #include <lua/lua.h>
+# This is because, the lua location is not standardized and may exist
+# in locations other than lua/
+
+
+FIND_PATH(LUA_INCLUDE_DIR lua.h
+  PATHS
+  $ENV{LUA_DIR}
+  NO_DEFAULT_PATH
+  PATH_SUFFIXES include/lua51 include/lua5.1 include/lua include
+)
+
+FIND_PATH(LUA_INCLUDE_DIR lua.h
+  PATHS
+  ~/Library/Frameworks
+  /Library/Frameworks
+  /usr/local
+  /usr
+  /sw # Fink
+  /opt/local # DarwinPorts
+  /opt/csw # Blastwave
+  /opt
+  PATH_SUFFIXES include/lua51 include/lua5.1 include/lua include
+)
+
+FIND_LIBRARY(LUA_LIBRARY 
+  NAMES lua51 lua5.1 lua
+  PATHS
+  $ENV{LUA_DIR}
+  NO_DEFAULT_PATH
+    PATH_SUFFIXES lib64 lib
+)
+
+FIND_LIBRARY(LUA_LIBRARY
+  NAMES lua51 lua5.1 lua
+  PATHS
+  ~/Library/Frameworks
+  /Library/Frameworks
+  /usr/local
+  /usr
+  /sw
+  /opt/local
+  /opt/csw
+  /opt
+    PATH_SUFFIXES lib64 lib
+)
+
+IF(LUA_LIBRARY)
+  # include the math library for Unix
+  IF(UNIX AND NOT APPLE)
+    FIND_LIBRARY(LUA_MATH_LIBRARY m)
+    SET( LUA_LIBRARIES "${LUA_LIBRARY};${LUA_MATH_LIBRARY}" CACHE STRING "Lua Libraries")
+  # For Windows and Mac, don't need to explicitly include the math library
+  ELSE(UNIX AND NOT APPLE)
+    SET( LUA_LIBRARIES "${LUA_LIBRARY}" CACHE STRING "Lua Libraries")
+  ENDIF(UNIX AND NOT APPLE)
+ENDIF(LUA_LIBRARY)
+
+INCLUDE(FindPackageHandleStandardArgs)
+# handle the QUIETLY and REQUIRED arguments and set LUA_FOUND to TRUE if 
+# all listed variables are TRUE
+FIND_PACKAGE_HANDLE_STANDARD_ARGS(Lua50  DEFAULT_MSG  LUA_LIBRARIES LUA_INCLUDE_DIR)
+
+MARK_AS_ADVANCED(LUA_INCLUDE_DIR LUA_LIBRARIES LUA_LIBRARY LUA_MATH_LIBRARY)
+
Index: /code/branches/buildsystem/src/CMakeLists.txt
===================================================================
--- /code/branches/buildsystem/src/CMakeLists.txt	(revision 1974)
+++ /code/branches/buildsystem/src/CMakeLists.txt	(revision 1975)
@@ -3,10 +3,11 @@
 INCLUDE_DIRECTORIES(ois) # for ois library subfolders
 INCLUDE_DIRECTORIES(orxonox)
-INCLUDE_DIRECTORIES(lua) # for tolua library and generator
+#INCLUDE_DIRECTORIES(lua) # for tolua library and generator
+INCLUDE_DIRECTORIES(${LUA_INCLUDE_DIR})
 
 ADD_SUBDIRECTORY(cpptcl)
 ADD_SUBDIRECTORY(ois)
 ADD_SUBDIRECTORY(tinyxml)
-ADD_SUBDIRECTORY(lua)
+#ADD_SUBDIRECTORY(lua)
 ADD_SUBDIRECTORY(tolua)
 
@@ -16,17 +17,16 @@
 # So first, find out what CEGUI version we have.
 
-IF (WIN32)
-    ADD_SUBDIRECTORY(ceguilua-0.6.1/ceguilua)
-    INCLUDE_DIRECTORIES(ceguilua-0.6.1)
-ELSE (WIN32)
-    IF (${CEGUI_VERSION} LESS 0.6.0)
-        ADD_SUBDIRECTORY(ceguilua-0.5.0b/ceguilua)
-        INCLUDE_DIRECTORIES(ceguilua-0.5.0b)
-    ELSE (${CEGUI_VERSION} LESS 0.6.0)
-        ADD_SUBDIRECTORY(ceguilua-0.6.1/ceguilua)
-        INCLUDE_DIRECTORIES(ceguilua-0.6.1)
-    ENDIF (${CEGUI_VERSION} LESS 0.6.0)
-ENDIF (WIN32)
-
+#IF (WIN32)
+#    ADD_SUBDIRECTORY(ceguilua-0.6.1/ceguilua)
+#    INCLUDE_DIRECTORIES(ceguilua-0.6.1)
+#ELSE (WIN32)
+#    IF (${CEGUI_VERSION} LESS 0.6.0)
+#        ADD_SUBDIRECTORY(ceguilua-0.5.0b/ceguilua)
+#        INCLUDE_DIRECTORIES(ceguilua-0.5.0b)
+#    ELSE (${CEGUI_VERSION} LESS 0.6.0)
+#        ADD_SUBDIRECTORY(ceguilua-0.6.1/ceguilua)
+#        INCLUDE_DIRECTORIES(ceguilua-0.6.1)
+#    ENDIF (${CEGUI_VERSION} LESS 0.6.0)
+#ENDIF (WIN32)
 
 # Our own libraries
Index: /code/branches/buildsystem/src/core/CMakeLists.txt
===================================================================
--- /code/branches/buildsystem/src/core/CMakeLists.txt	(revision 1974)
+++ /code/branches/buildsystem/src/core/CMakeLists.txt	(revision 1975)
@@ -61,5 +61,5 @@
   ${Boost_thread_LIBRARIES}
   ${Boost_filesystem_LIBRARIES}
-  lua_orxonox
+  ${LUA_LIBRARIES}
   cpptcl_orxonox
   ois_orxonox
Index: /code/branches/buildsystem/src/core/Script.cc
===================================================================
--- /code/branches/buildsystem/src/core/Script.cc	(revision 1974)
+++ /code/branches/buildsystem/src/core/Script.cc	(revision 1975)
@@ -34,5 +34,8 @@
 #include "CoreIncludes.h"
 
-#include "lua/lua.hpp"
+extern "C" {
+#include "lua.h"
+#include "lualib.h"
+}
 
 #include "tolua++.h"
Index: /code/branches/buildsystem/src/core/Script.h
===================================================================
--- /code/branches/buildsystem/src/core/Script.h	(revision 1974)
+++ /code/branches/buildsystem/src/core/Script.h	(revision 1975)
@@ -39,5 +39,5 @@
 
 extern "C" {
-#include "lua/lua.h"
+#include "lua.h"
 }
 
Index: /code/branches/buildsystem/src/orxonox/CMakeLists.txt
===================================================================
--- /code/branches/buildsystem/src/orxonox/CMakeLists.txt	(revision 1974)
+++ /code/branches/buildsystem/src/orxonox/CMakeLists.txt	(revision 1975)
@@ -97,6 +97,6 @@
   ${OGRE_LIBRARIES}
   ${CEGUI_LIBRARIES}
-  lua_orxonox
-  ceguilua_orxonox
+  ${LUA_LIBRARIES}
+  CEGUILuaScriptModule
   tinyxml_orxonox
   tolualib_orxonox
Index: /code/branches/buildsystem/src/orxonox/gui/GUIManager.cc
===================================================================
--- /code/branches/buildsystem/src/orxonox/gui/GUIManager.cc	(revision 1974)
+++ /code/branches/buildsystem/src/orxonox/gui/GUIManager.cc	(revision 1975)
@@ -39,5 +39,5 @@
 #include <OgreRoot.h>
 #include <CEGUI.h>
-#include "ceguilua/CEGUILua.h"
+#include <CEGUILua.h>
 #include "util/Exception.h"
 #include "core/input/InputManager.h"
@@ -50,5 +50,7 @@
 #include "OgreCEGUIRenderer.h"
 
-#include "lua/lua.hpp"
+extern "C" {
+#include "lua.h"
+}
 
 namespace orxonox
Index: /code/branches/buildsystem/src/tolua/CMakeLists.txt
===================================================================
--- /code/branches/buildsystem/src/tolua/CMakeLists.txt	(revision 1974)
+++ /code/branches/buildsystem/src/tolua/CMakeLists.txt	(revision 1975)
@@ -1,2 +1,4 @@
+# TODO: only build the object files once
+
 SET (TOLUALIB_SRC_FILES
   tolua_event.c
@@ -8,9 +10,5 @@
 
 ADD_LIBRARY (tolualib_orxonox SHARED ${TOLUALIB_SRC_FILES})
-
-TARGET_LINK_LIBRARIES (tolualib_orxonox
-  lua_orxonox
-)
-
+TARGET_LINK_LIBRARIES (tolualib_orxonox ${LUA_LIBRARIES})
 
 SET (TOLUAGEN_SRC_FILES
@@ -19,12 +17,6 @@
 )
 
-ADD_EXECUTABLE (toluagen_orxonox ${TOLUAGEN_SRC_FILES})
-
-TARGET_LINK_LIBRARIES (toluagen_orxonox
-  lua_orxonox
-  tolualib_orxonox
-  m
-)
-
+ADD_EXECUTABLE (toluagen_orxonox ${TOLUAGEN_SRC_FILES} ${TOLUALIB_SRC_FILES})
+TARGET_LINK_LIBRARIES (toluagen_orxonox ${LUA_LIBRARIES})
 
 SET (TOLUA_PACKAGE "${CMAKE_CURRENT_SOURCE_DIR}/tolua-5.1.pkg")
@@ -65,9 +57,4 @@
 )
 
-ADD_EXECUTABLE (tolua_orxonox ${TOLUAEXE_SRC_FILES})
-
-TARGET_LINK_LIBRARIES (tolua_orxonox
-  lua_orxonox
-  tolualib_orxonox
-  m
-)
+ADD_EXECUTABLE (tolua_orxonox ${TOLUAEXE_SRC_FILES} ${TOLUALIB_SRC_FILES})
+TARGET_LINK_LIBRARIES (tolua_orxonox ${LUA_LIBRARIES})
Index: /code/branches/buildsystem/src/tolua/tolua++.h
===================================================================
--- /code/branches/buildsystem/src/tolua/tolua++.h	(revision 1974)
+++ /code/branches/buildsystem/src/tolua/tolua++.h	(revision 1975)
@@ -65,6 +65,6 @@
 typedef int lua_Object;
 
-#include "lua/lua.h"
-#include "lua/lauxlib.h"
+#include "lua.h"
+#include "lauxlib.h"
 
 struct tolua_Error
Index: /code/branches/buildsystem/src/tolua/tolua.c
===================================================================
--- /code/branches/buildsystem/src/tolua/tolua.c	(revision 1974)
+++ /code/branches/buildsystem/src/tolua/tolua.c	(revision 1975)
@@ -15,7 +15,7 @@
 #include "tolua++.h"
 
-#include "lua/lua.h"
-#include "lua/lualib.h"
-#include "lua/lauxlib.h"
+#include "lua.h"
+#include "lualib.h"
+#include "lauxlib.h"
 
 #include <stdio.h>
Index: /code/branches/buildsystem/src/tolua/tolua_is.c
===================================================================
--- /code/branches/buildsystem/src/tolua/tolua_is.c	(revision 1974)
+++ /code/branches/buildsystem/src/tolua/tolua_is.c	(revision 1975)
@@ -14,5 +14,5 @@
 
 #include "tolua++.h"
-#include "lua/lauxlib.h"
+#include "lauxlib.h"
 
 #include <stdlib.h>
Index: /code/branches/buildsystem/src/tolua/tolua_map.c
===================================================================
--- /code/branches/buildsystem/src/tolua/tolua_map.c	(revision 1974)
+++ /code/branches/buildsystem/src/tolua/tolua_map.c	(revision 1975)
@@ -15,5 +15,5 @@
 #include "tolua++.h"
 #include "tolua_event.h"
-#include "lua/lauxlib.h"
+#include "lauxlib.h"
 
 #include <string.h>
Index: /code/branches/buildsystem/src/tolua/tolua_push.c
===================================================================
--- /code/branches/buildsystem/src/tolua/tolua_push.c	(revision 1974)
+++ /code/branches/buildsystem/src/tolua/tolua_push.c	(revision 1975)
@@ -14,5 +14,5 @@
 
 #include "tolua++.h"
-#include "lua/lauxlib.h"
+#include "lauxlib.h"
 
 #include <stdlib.h>
